#!/usr/bin/env python

# A Python attempt at auto-RDFa conversion, based on this shell+vi script from Niklas in rdfa wg

#    %s/itemscope itemtype="[^"]*schema.org\/\([^"]\+\)"/typeof="\1"/g
#    %s#WITH\s\+MARKUP:\_s\+<\w\+#& vocab="http://schema.org/"#
#    %s/\<itemprop\>=/property=/g
#    %s/\<itemid/resource/g

# Usage:
# ./liter.py -i grs1.html -o - > grs1-autordfa.html
#
# (I meant to use -o option for writing out to named file, but life's too short; we only have a handful of examples anyway)

# Limitations: plenty. 
# See http://stackoverflow.com/questions/1732348/regex-match-open-tags-except-xhtml-self-contained-tags/1732454#1732454 
# Specifically, we assume we'll find Microdata written in certain shaped markup; other variants are legal. 
# Check afterwards with 'grep' or similar to see if itemprop/itemtype/itemscope sneaked through.
# e.g. egrep "itemprop|itemtype" *rdfa.html

import sys, getopt, traceback, re

def usage():
  print "Usage e.g. ./liter.py -i grs1.html -o -"

# IN:  Blah blah this is a sentence <span itemscope itemtype="http://schema.org/Person"><span itemprop="name">Stan</span></span>

def liter(str):

  #  %s/itemscope itemtype="[^"]*schema.org\/\([^"]\+\)"/typeof="\1"/g
  def type_regex_fn(m):
    return "typeof=\"" + m.group(2) + "\""

  type_regex = re.compile(r'itemscope(="[^"]*")? itemtype="[^"]*schema.org/([^"]+)"')

  str = re.sub(type_regex, type_regex_fn, str)

  #    %s#WITH\s\+MARKUP:\_s\+<\w\+#& vocab="http://schema.org/"#
  vocab_regex = re.compile(r'<body')
  str = re.sub(vocab_regex, '<body vocab="http://schema.org/" ', str)

  #    %s/\<itemprop\>=/property=/g
  prop_regex = re.compile(r'itemprop=')
  str = re.sub(prop_regex, 'property=', str)

  #    %s/\<itemid/resource/g

  id_regex = re.compile(r'itemid=')
  str = re.sub(id_regex, 'resource=" ', str)

  # print "NOW: ",str
  return str

def main(argv):                          

    infile="" 
    outfile=""

    try:                                
        opts, args = getopt.getopt(argv, "hi:o:d", ["help", "in=", "out="])
    except getopt.GetoptError:
        exc_type, exc_value, exc_traceback = sys.exc_info()
        print "Oops: "
        traceback.print_exception(exc_type, exc_value, exc_traceback,
                              limit=2, file=sys.stdout)
        usage()                         
        sys.exit(2)                     
    for opt, arg in opts:                
        if opt in ("-h", "--help"):      
            usage()                     
            sys.exit()                  
        elif opt == '-d':                
            global _debug               
            _debug = 1                  
        elif opt in ("-i", "--in"): 
            infile = arg               
        elif opt in ("-o", "--out"): 
            outfile = arg               

    source = "".join(args)               

#    print "infile: ", infile
#    print "outfile: ", outfile

    f = open(infile)
    for line in f:
      print liter(line)
    f.close()

if __name__ == "__main__":
    main(sys.argv[1:])
